const TblEmpresa = require("../models/TblEmpresas");

const getAllEmpresas = async (queryParams = {}) => {
  return TblEmpresa.findAll({
    where: queryParams,
  });
};

const getEmpresaById = async (id, queryParams = {}) => {
  const whereCondition = { intId: id, ...queryParams };

  return TblEmpresa.findOne({
    where: whereCondition,
  });
};



const createEmpresa = async (empresaData) => {
  return TblEmpresa.create(empresaData);
};

const updateEmpresa = async (id, empresaData) => {
  const empresa = await TblEmpresa.findByPk(id);
  if (!empresa) {
    throw new Error("Empresa not found");
  }
  return empresa.update(empresaData);
};

const deleteEmpresa = async (id) => {
  // Assuming TblEmpresa is your Sequelize model
  const result = await TblEmpresa.update(
    { bitEliminado: true },
    { where: { intId: id } }
  );

  // The 'result' object contains information about the operation
  const affectedRows = result[0];

  if (affectedRows === 0) {
    throw new Error("Empresa not found");
  }

  // You might want to return additional information if needed
  return { success: true, message: "Empresa soft deleted successfully" };
};

module.exports = {
  getAllEmpresas,
  getEmpresaById,
  createEmpresa,
  updateEmpresa,
  deleteEmpresa,
};
